<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (26)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="ninja-code">Ninja code</h1>
    <p>
      Learning without thought is labor lost; thought without learning is
      perilous.
    </p>
    <pre><code>
Programmer ninjas of the past used these tricks to sharpen the mind of code maintainers.

Code review gurus look for them in test tasks.

Novice developers sometimes use them even better than programmer ninjas.

Read them carefully and find out who you are -- a ninja, a novice, or maybe a code reviewer?

```warn header=&quot;Irony detected&quot;
Many try to follow ninja paths. Few succeed.</code></pre>
    <h2 id="brevity-is-the-soul-of-wit">Brevity is the soul of wit</h2>
    <p>Make the code as short as possible. Show how smart you are.</p>
    <p>Let subtle language features guide you.</p>
    <p>For instance, take a look at this ternary operator <code>'?'</code>:</p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="co">// taken from a well-known javascript library</span></a>
<a class="sourceLine" id="cb2-2" title="2">i <span class="op">=</span> i <span class="op">?</span> (i <span class="op">&lt;</span> <span class="dv">0</span> <span class="op">?</span> <span class="va">Math</span>.<span class="at">max</span>(<span class="dv">0</span><span class="op">,</span> len <span class="op">+</span> i) : i) : <span class="dv">0</span><span class="op">;</span></a></code></pre>
    </div>
    <p>
      Cool, right? If you write like that, a developer who comes across this
      line and tries to understand what is the value of <code>i</code> is going
      to have a merry time. Then come to you, seeking for an answer.
    </p>
    <p>
      Tell them that shorter is always better. Initiate them into the paths of
      ninja.
    </p>
    <h2 id="one-letter-variables">One-letter variables</h2>
    <p>
      The Dao hides in wordlessness. Only the Dao is well begun and well
      completed.
    </p>
    <pre><code>
Another way to code shorter is to use single-letter variable names everywhere. Like `a`, `b` or `c`.

A short variable disappears in the code like a real ninja in the forest. No one will be able to find it using &quot;search&quot; of the editor. And even if someone does, they won&#39;t be able to &quot;decipher&quot; what the name `a` or `b` means.

...But there&#39;s an exception. A real ninja will never use `i` as the counter in a `&quot;for&quot;` loop. Anywhere, but not here. Look around, there are many more exotic letters. For instance, `x` or `y`.

An exotic variable as a loop counter is especially cool if the loop body takes 1-2 pages (make it longer if you can). Then if someone looks deep inside the loop, they won&#39;t be able to quickly figure out that the variable named `x` is the loop counter.

## Use abbreviations

If the team rules forbid the use of one-letter and vague names -- shorten them, make abbreviations.

Like this:

- `list` -&gt; `lst`.
- `userAgent` -&gt; `ua`.
- `browser` -&gt; `brsr`.
- ...etc

Only the one with truly good intuition will be able to understand such names. Try to shorten everything. Only a worthy person should be able to uphold the development of your code.

## Soar high. Be abstract.

The great square is cornerless&lt;br&gt;
The great vessel is last complete,&lt;br&gt;
The great note is rarified sound,&lt;br&gt;
The great image has no form.</code></pre>
    <p>
      While choosing a name try to use the most abstract word. Like
      <code>obj</code>, <code>data</code>, <code>value</code>,
      <code>item</code>, <code>elem</code> and so on.
    </p>
    <ul>
      <li>
        <p>
          <strong>The ideal name for a variable is <code>data</code>.</strong>
          Use it everywhere you can. Indeed, every variable holds <em>data</em>,
          right?
        </p>
        <p>
          …But what to do if <code>data</code> is already taken? Try
          <code>value</code>, it’s also universal. After all, a variable
          eventually gets a <em>value</em>.
        </p>
      </li>
      <li>
        <p>
          <strong
            >Name a variable by its type: <code>str</code>,
            <code>num</code>…</strong
          >
        </p>
        <p>
          Give them a try. A young initiate may wonder – are such names really
          useful for a ninja? Indeed, they are!
        </p>
        <p>
          Sure, the variable name still means something. It says what’s inside
          the variable: a string, a number or something else. But when an
          outsider tries to understand the code, they’ll be surprised to see
          that there’s actually no information at all! And will ultimately fail
          to alter your well-thought code.
        </p>
        <p>
          The value type is easy to find out by debugging. But what’s the
          meaning of the variable? Which string/number does it store?
        </p>
        <p>There’s just no way to figure out without a good meditation!</p>
      </li>
      <li>
        <p>
          <strong>…But what if there are no more such names?</strong> Just add a
          number: <code>data1, item2, elem5</code>…
        </p>
      </li>
    </ul>
    <h2 id="attention-test">Attention test</h2>
    <p>
      Only a truly attentive programmer should be able to understand your code.
      But how to check that?
    </p>
    <p>
      <strong
        >One of the ways – use similar variable names, like
        <code>date</code> and <code>data</code>.</strong
      >
    </p>
    <p>Mix them where you can.</p>
    <p>
      A quick read of such code becomes impossible. And when there’s a typo…
      Ummm… We’re stuck for long, time to drink tea.
    </p>
    <h2 id="smart-synonyms">Smart synonyms</h2>
    <p>
      The Tao that can be told is not the eternal Tao. The name that can be
      named is not the eternal name.
    </p>
    <pre><code>
Using _similar_ names for _same_ things makes life more interesting and shows your creativity to the public.

For instance, consider function prefixes. If a function shows a message on the screen -- start it with `display…`, like `displayMessage`. And then if another function shows on the screen something else, like a user name, start it with `show…` (like `showName`).

Insinuate that there&#39;s a subtle difference between such functions, while there is none.

Make a pact with fellow ninjas of the team: if John starts &quot;showing&quot; functions with `display...` in his code, then Peter could use `render..`, and Ann -- `paint...`. Note how much more interesting and diverse the code became.

...And now the hat trick!

For two functions with important differences -- use the same prefix!

For instance, the function `printPage(page)` will use a printer. And the function `printText(text)` will put the text on-screen. Let an unfamiliar reader think well over similarly named function `printMessage`: &quot;Where does it put the message? To a printer or on the screen?&quot;. To make it really shine, `printMessage(message)` should output it in the new window!

## Reuse names

Once the whole is divided, the parts&lt;br&gt;
need names.&lt;br&gt;
There are already enough names.&lt;br&gt;
One must know when to stop.</code></pre>
    <p>Add a new variable only when absolutely necessary.</p>
    <p>Instead, reuse existing names. Just write new values into them.</p>
    <p>In a function try to use only variables passed as parameters.</p>
    <p>
      That would make it really hard to identify what’s exactly in the variable
      <em>now</em>. And also where it comes from. The purpose is to develop the
      intuition and memory of a person reading the code. A person with weak
      intuition would have to analyze the code line-by-line and track the
      changes through every code branch.
    </p>
    <p>
      <strong
        >An advanced variant of the approach is to covertly (!) replace the
        value with something alike in the middle of a loop or a
        function.</strong
      >
    </p>
    <p>For instance:</p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">function</span> <span class="at">ninjaFunction</span>(elem) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="co">// 20 lines of code working with elem</span></a>
<a class="sourceLine" id="cb5-3" title="3"></a>
<a class="sourceLine" id="cb5-4" title="4">  elem <span class="op">=</span> <span class="at">clone</span>(elem)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-5" title="5"></a>
<a class="sourceLine" id="cb5-6" title="6">  <span class="co">// 20 more lines, now working with the clone of the elem!</span></a>
<a class="sourceLine" id="cb5-7" title="7"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      A fellow programmer who wants to work with <code>elem</code> in the second
      half of the function will be surprised… Only during the debugging, after
      examining the code they will find out that they’re working with a clone!
    </p>
    <p>
      Seen in code regularly. Deadly effective even against an experienced
      ninja.
    </p>
    <h2 id="underscores-for-fun">Underscores for fun</h2>
    <p>
      Put underscores <code>_</code> and <code>__</code> before variable names.
      Like <code>_name</code> or <code>__value</code>. It would be great if only
      you knew their meaning. Or, better, add them just for fun, without
      particular meaning at all. Or different meanings in different places.
    </p>
    <p>
      You kill two rabbits with one shot. First, the code becomes longer and
      less readable, and the second, a fellow developer may spend a long time
      trying to figure out what the underscores mean.
    </p>
    <p>
      A smart ninja puts underscores at one spot of code and evades them at
      other places. That makes the code even more fragile and increases the
      probability of future errors.
    </p>
    <h2 id="show-your-love">Show your love</h2>
    <p>
      Let everyone see how magnificent your entities are! Names like
      <code>superElement</code>, <code>megaFrame</code> and
      <code>niceItem</code> will definitely enlighten a reader.
    </p>
    <p>
      Indeed, from one hand, something is written: <code>super..</code>,
      <code>mega..</code>, <code>nice..</code> But from the other hand – that
      brings no details. A reader may decide to look for a hidden meaning and
      meditate for an hour or two of their paid working time.
    </p>
    <h2 id="overlap-outer-variables">Overlap outer variables</h2>
    <p>
      When in the light, can’t see anything in the darkness.<br />
      When in the darkness, can see everything in the light.
    </p>
    <pre><code>
Use same names for variables inside and outside a function. As simple. No efforts to invent new names.

```js
let *!*user*/!* = authenticateUser();

function render() {
  let *!*user*/!* = anotherValue();
  ...
  ...many lines...
  ...
  ... // &lt;-- a programmer wants to work with user here and...
  ...
}</code></pre>
    <p>
      A programmer who jumps inside the <code>render</code> will probably fail
      to notice that there’s a local <code>user</code> shadowing the outer one.
    </p>
    <p>
      Then they’ll try to work with <code>user</code> assuming that it’s the
      external variable, the result of <code>authenticateUser()</code>… The trap
      is sprung! Hello, debugger…
    </p>
    <h2 id="side-effects-everywhere">Side-effects everywhere!</h2>
    <p>
      There are functions that look like they don’t change anything. Like
      <code>isReady()</code>, <code>checkPermission()</code>,
      <code>findTags()</code>… They are assumed to carry out calculations, find
      and return the data, without changing anything outside of them. In other
      words, without “side-effects”.
    </p>
    <p>
      <strong
        >A really beautiful trick is to add a “useful” action to them, besides
        the main task.</strong
      >
    </p>
    <p>
      An expression of dazed surprise on the face of your colleague when they
      see a function named <code>is..</code>, <code>check..</code> or
      <code>find...</code> changing something – will definitely broaden your
      boundaries of reason.
    </p>
    <p>
      <strong
        >Another way to surprise is to return a non-standard result.</strong
      >
    </p>
    <p>
      Show your original thinking! Let the call of
      <code>checkPermission</code> return not <code>true/false</code>, but a
      complex object with the results of the check.
    </p>
    <p>
      Those developers who try to write <code>if (checkPermission(..))</code>,
      will wonder why it doesn’t work. Tell them: “Read the docs!”. And give
      this article.
    </p>
    <h2 id="powerful-functions">Powerful functions!</h2>
    <p>
      The great Tao flows everywhere,<br />
      both to the left and to the right.
    </p>
    <pre><code>
Don&#39;t limit the function by what&#39;s written in its name. Be broader.

For instance, a function `validateEmail(email)` could (besides checking the email for correctness) show an error message and ask to re-enter the email.

Additional actions should not be obvious from the function name. A true ninja coder will make them not obvious from the code as well.

**Joining several actions into one protects your code from reuse.**

Imagine, another developer wants only to check the email, and not output any message. Your function `validateEmail(email)` that does both will not suit them. So they won&#39;t break your meditation by asking anything about it.

## Summary

All &quot;pieces of advice&quot; above are from the real code... Sometimes, written by experienced developers. Maybe even more experienced than you are ;)

- Follow some of them, and your code will become full of surprises.
- Follow many of them, and your code will become truly yours, no one would want to change it.
- Follow all, and your code will become a valuable lesson for young developers looking for enlightenment.</code></pre>
  </body>
</html>
